!include "..\Common.nsh"

;-----------------------------------------------------------------------
; MAIN SCRIPT

SetCompressor /SOLID lzma

!include "MUI.nsh"

Name "FileRenamer"
OutFile "FileRenamer_v1.0.exe"

InstallDir "$PROGRAMFILES\Arnapou\FileRenamer"
InstallDirRegKey HKCU "Software\Arnapou\FileRenamer" ""

!define MUI_ABORTWARNING

;!insertmacro MUI_PAGE_LICENSE "licence.txt"
;!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

!insertmacro MUI_LANGUAGE "English" ;first language is the default language
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Portuguese"

InstType "Normal"

Section "Programmes" Sec_Program
	SectionIn 1 RO
	SetOutPath $INSTDIR
	File "FileRenamer.exe"
	SetShellVarContext current
	CreateDirectory "$SMPROGRAMS\Arnapou"
	CreateDirectory "$SMPROGRAMS\Arnapou\FileRenamer"
	CreateShortCut "$SMPROGRAMS\Arnapou\FileRenamer\FileRenamer.lnk" "$INSTDIR\FileRenamer.exe"
SectionEnd

Section -PostInstall Sec_PostInstall
	WriteUninstaller "$INSTDIR\uninstall.exe"
	WriteRegStr HKCU "Software\Arnapou\FileRenamer" "" '"$INSTDIR"'
	CreateShortCut "$SMPROGRAMS\Arnapou\FileRenamer\Uninstall.lnk" "$INSTDIR\uninstall.exe"
	SetShellVarContext current
	!insertmacro AddRemovePanel_ADD "Arnapou / FileRenamer" "1.0" "786" "$INSTDIR\uninstall.exe"
SectionEnd 

UninstallText "Uninstall Arnapou FileRenamer ?"

Section "Uninstall" Sec_Uninstall	
	SetOutPath $TEMP
	DetailPrint "FileRenamer is installed on : $INSTDIR"
	RMDir /r /REBOOTOK "$INSTDIR"
	SetShellVarContext current
	RMDir /r "$SMPROGRAMS\Arnapou\FileRenamer"
	
	!insertmacro AddRemovePanel_REMOVE "Arnapou / FileRenamer"
SectionEnd 
