unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ImgList;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Folder: TEdit;
    Label1: TLabel;
    BFolder: TBitBtn;
    Files: TListView;
    GroupBox3: TGroupBox;
    Panel4: TPanel;
    Panel5: TPanel;
    Rules: TListView;
    Panel6: TPanel;
    Label2: TLabel;
    RuleSearch: TEdit;
    Panel7: TPanel;
    Label3: TLabel;
    RuleReplace: TEdit;
    Panel8: TPanel;
    BAddRule: TBitBtn;
    RuleRegExp: TCheckBox;
    BDeleteRule: TBitBtn;
    BUP: TBitBtn;
    BDOWN: TBitBtn;
    BTOP: TBitBtn;
    BBOTTOM: TBitBtn;
    Splitter1: TSplitter;
    TN: TImageList;
    BModify: TBitBtn;
    Panel9: TPanel;
    BUP2: TBitBtn;
    BDOWN2: TBitBtn;
    BTOP2: TBitBtn;
    BBOTTOM2: TBitBtn;
    BitBtn1: TBitBtn;
    BExit: TBitBtn;
    BHELP: TBitBtn;
    RuleCase: TCheckBox;
    Panel2: TPanel;
    BRUN: TBitBtn;
    procedure FolderChange(Sender: TObject);
    procedure BFolderClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BDeleteRuleClick(Sender: TObject);
    procedure RulesDblClick(Sender: TObject);
    procedure BModifyClick(Sender: TObject);
    procedure BTOPClick(Sender: TObject);
    procedure BBOTTOMClick(Sender: TObject);
    procedure BAddRuleClick(Sender: TObject);
    procedure BUPClick(Sender: TObject);
    procedure BDOWNClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BExitClick(Sender: TObject);
    procedure BTOP2Click(Sender: TObject);
    procedure BUP2Click(Sender: TObject);
    procedure BDOWN2Click(Sender: TObject);
    procedure BBOTTOM2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Remplacements;             
    function Remplace(S:string; Num:integer):string;
    procedure BRUNClick(Sender: TObject);
    procedure BHELPClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
  TRule= class
    private
    public
    Casse: boolean;
    RegExp: boolean;
    Search: string;
    Replace: string;
    procedure LoadFrom(item:TListItem);
    procedure LoadInto(item:TListItem);
    function Remplace(S:string):string;
  end;


var
  Form1: TForm1;
  Rule: TRule;

implementation

uses common, commonregex, Help;

{$R *.dfm}
                                                
//-------------------------------------------------------------
function TRule.Remplace(S:string):string;
begin
  Result := S;
  if RegExp then begin
    if Casse then
      Result := RegReplace(Result, Search, Replace)
    else
      Result := RegReplaceI(Result, Search, Replace);
  end else begin   
    if Casse then
      Result := StrReplace(Result, Search, Replace)
    else
      Result := StrReplaceI(Result, Search, Replace);
  end;
end;
//-------------------------------------------------------------
procedure TRule.LoadFrom(item:TListItem);
begin
  Casse := (item.ImageIndex<>0);
  RegExp := (item.SubItemImages[0]<>0);
  Search := item.SubItems[1];
  Replace := item.SubItems[2];
end;
//-------------------------------------------------------------
procedure TRule.LoadInto(item:TListItem);
begin
  item.Caption := '';
  item.SubItems.Clear;
  item.SubItems.Add('');
  item.SubItems.Add(Search);
  item.SubItems.Add(Replace);
  item.ImageIndex := 0;
  item.SubItemImages[0] := 0;
  if Casse then item.ImageIndex := 1;
  if RegExp then item.SubItemImages[0] := 1;
end;
//-------------------------------------------------------------
procedure TForm1.Remplacements;
var
  i : integer;
begin
  for i := 0 to Files.items.Count - 1 do begin
    Files.Items[i].SubItems[0] := Remplace(Files.Items[i].Caption, i);
  end;
end;        
//-------------------------------------------------------------
function TForm1.Remplace(S:string; Num:integer):string;
var
  i : integer;
begin
  Result:= S;
  for i := 0 to Rules.Items.Count - 1 do begin
    Rule.LoadFrom(Rules.Items[i]);
    Result := Rule.Remplace(Result);
  end;
  Result := StrReplace(Result, '%%1', IntToStr(Num));
  for I := 2 to 5 do
    Result := StrReplace(Result, '%%'+IntToStr(i), StrPadLeft(Num, i, '0'));
end;
//-------------------------------------------------------------
procedure TForm1.BDeleteRuleClick(Sender: TObject);
begin
  if Rules.ItemIndex>=0 then Rules.ItemFocused.Delete;  
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BFolderClick(Sender: TObject);
begin
  selectfolder(Folder, 'Select Folder');     
end;            
//-------------------------------------------------------------
procedure TForm1.BHELPClick(Sender: TObject);
begin
  Form2.ShowModal;
end;
//-------------------------------------------------------------
procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  FolderChange(Folder);
end;            
//-------------------------------------------------------------
procedure TForm1.BRUNClick(Sender: TObject);
var
  i : integer;
  F, Src, Dst:string;
  OK : boolean;
begin
  F:=getdirslash(Folder.Text);
  if directoryexists(F) then begin
    ok := true;
    for i := 0 to Files.items.Count - 1 do begin
      src := F+Files.Items[i].Caption;
      dst := F+Files.Items[i].subitems[0];
      if (src<>dst) then
        if not(fileexists(dst)) then begin
          try
            RenameFile(src, dst);
          except
            MsgError('Unattended Error', 'ERROR');
            Exit;
          end;
          Files.Items[i].Caption := Files.Items[i].subitems[0];
          Files.Items[i].subitems[0] := Remplace(Files.Items[i].Caption, i);
        end else begin
          ok:= false;
          Files.Items[i].subitems[0] := '>>> '+Files.Items[i].subitems[0];
        end;
    end;
    if ok=false then
      MsgError('Some files couldn''t be renamed because they exists', '');
  end else
    MsgError('The typed folder doesn''t exists', '');
end;
//-------------------------------------------------------------
procedure TForm1.BModifyClick(Sender: TObject);
begin
  if Rules.ItemIndex>=0 then begin
    if ruleSearch.Text<>'' then begin
      Rule.Casse := ruleCase.Checked;
      Rule.RegExp := ruleRegExp.Checked;
      Rule.Search := ruleSearch.Text;
      Rule.Replace := ruleReplace.Text;
      Rule.LoadInto(rules.ItemFocused);
    end;
  end;    
  Remplacements;
end;          
//-------------------------------------------------------------
procedure TForm1.BTOP2Click(Sender: TObject);
begin
  TListViewTop(Files);                 
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BTOPClick(Sender: TObject);
begin
  TListViewTop(Rules);                  
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BUP2Click(Sender: TObject);
begin
  TListViewUp(Files);              
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BUPClick(Sender: TObject);
begin
  TListViewUp(Rules);              
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BDOWN2Click(Sender: TObject);
begin
  TListViewDown(Files);              
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BDOWNClick(Sender: TObject);
begin
  TListViewDown(Rules);  
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BBOTTOM2Click(Sender: TObject);
begin
  TListViewBottom(Files);                
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BBOTTOMClick(Sender: TObject);
begin
  TListViewBottom(Rules);    
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.BExitClick(Sender: TObject);
begin
  Close
end;
//-------------------------------------------------------------
procedure TForm1.BAddRuleClick(Sender: TObject);
var
  item : tlistitem;
begin
  if ruleSearch.Text<>'' then begin 
    Rule.Casse := ruleCase.Checked;
    Rule.RegExp := ruleRegExp.Checked;
    Rule.Search := ruleSearch.Text;
    Rule.Replace := ruleReplace.Text;
    Rule.LoadInto(rules.Items.Add);
  end;
  SelectItem(Rules,rules.Items.Count-1);
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.FolderChange(Sender: TObject);
var
  List : TStringLIst;
  i : integer;
  item: TListItem;
begin
  Files.Clear;
  if ValidFolder(Sender) then begin
    List := TSTringList.Create;
    try
      SearchFiles(Folder.Text, False, List);
      for i := 0 to List.Count - 1 do begin
        item := Files.Items.Add;
        item.Caption := basename(List[i]);
        item.SubItems.Add(item.Caption);
      end;
    finally
      List.Free;
    end;
  end;             
  Remplacements;
end;
//-------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Files.Clear;
  Rules.Clear;
  Rule := TRule.Create;
end;
//-------------------------------------------------------------
procedure TForm1.FormResize(Sender: TObject);
var W:integer;
begin
  panel6.Width := ToInt((groupbox3.ClientWidth-panel8.Width)/2);
  W:= ToInt((Rules.Width-Rules.Columns[0].Width-Rules.Columns[1].Width-25)/2);
  Rules.Columns[2].Width := W;
  Rules.Columns[3].Width := W;                                  
  W:= ToInt((Files.Width-25)/2);
  Files.Columns[0].Width := W;
  Files.Columns[1].Width := W;
  panel2.Width := toint((self.ClientWidth-BHELP.Width)/2);
end;
//-------------------------------------------------------------
procedure TForm1.RulesDblClick(Sender: TObject);
begin
  if Rules.ItemIndex>=0 then begin
    Rule.LoadFrom(rules.ItemFocused);
    ruleCase.Checked := Rule.Casse;
    ruleRegExp.Checked := Rule.RegExp;
    ruleSearch.Text := Rule.Search;
    ruleReplace.Text := Rule.Replace;
  end;
end;
//-------------------------------------------------------------

end.
